您的位置:首页 > 编程语言 > Java开发

leetcode TwoSum

2015-03-04 17:18 288 查看
题目如下:

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

解题思路:

利用HashTable判断重复,循环时可以将题意转为求总和与这个值的差值是否在数组中,由于HashTable查找一个数的时间为是常数,所以总的时间复杂度为O(N)

代码:

public int[] twoSum(int[] numbers, int target) {
int index[] = new int[2];
Hashtable<Integer, Integer> nums = new Hashtable<Integer, Integer>();
for (int i = 0; i < numbers.length; i++) {
Integer n = nums.get(numbers[i]);
if (n == null)
nums.put(numbers[i], i);
n = nums.get(target - numbers[i]);
if (n != null && n < i) {//n<i的目的是自己不能加自己
index[0] = n + 1;
index[1] = i + 1;
return index;
}
}

return index;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  java leetcode 算法 TwoSum